# Invoke-RASTemplate.md

## NAME

Invoke-RASTemplate

## SYNOPSIS

Perform RAS Template commands.

## SYNTAX

**Invoke-RASTemplate** \[[Id](#id-string)] *(uint)* -[Command](#Command) {EnterMaintenance | ExitMaintenance | RecreateHosts | RecreateDesktops} -[ObjType](#objtype) {RDSTemplate | VDITemplate | AVDTemplate} \[[CreateTemplateVersion](#createtemplateversion-string) *(SwitchParameter)*] \[[ForceStopUpdateHosts](#forcestopupdatehosts-string) *(SwitchParameter)*] \[[RecreateAllHosts](#recreateallhosts-string) *(SwitchParameter)*] \[[TemplateVersionId](#templateversionid-string) *(uint)*] \[[VDIHostId](#vdihostid-string) *(string)*] \[*(*[*CommonParameters*](#CommonParameters)*)*]

\*\*Invoke-RASTemplate \[-[InputObject](#inputobject)] *(*[*Template*](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/types/template.md)*)* -[Command](#Command) {EnterMaintenance | ExitMaintenance | RecreateHosts | RecreateDesktops} -[ObjType](#objtype) {RDSTemplate | VDITemplate | AVDTemplate} \[[CreateTemplateVersion](#createtemplateversion-string) *(SwitchParameter)*] \[[ForceStopUpdateHosts](#forcestopupdatehosts-string) *(SwitchParameter)*] \[[RecreateAllHosts](#recreateallhosts-string) *(SwitchParameter)*] \[[TemplateVersionId](#templateversionid-string) *(uint)*] \[[VDIHostId](#vdihostid-string) *(string)*] \[*(*[*CommonParameters*](#CommonParameters)*)*]

**Invoke-RASTemplate** \[[Name](#name-string)] *(string)* \[\[-[SiteId](#siteid-string)] *(uint)*] -[Command](#Command) {EnterMaintenance | ExitMaintenance | RecreateHosts | RecreateDesktops} -[ObjType](#objtype) {RDSTemplate | VDITemplate | AVDTemplate} \[[CreateTemplateVersion](#createtemplateversion-string) *(SwitchParameter)*] \[[ForceStopUpdateHosts](#forcestopupdatehosts-string) *(SwitchParameter)*] \[[RecreateAllHosts](#recreateallhosts-string) *(SwitchParameter)*] \[[TemplateVersionId](#templateversionid-string) *(uint)*] \[[VDIHostId](#vdihostid-string) *(string)*] \[*(*[*CommonParameters*](#CommonParameters)*)*]

## DESCRIPTION

Triggers an action on the selected Template such as: EnterMaintenance, ExitMaintenance or RecreateHosts.

EnterMaintenance: Toggle the template into maintenance mode.

ExitMaintenance: Toggle the template out from maintenance mode.

RecreateHosts: Re-creates one or all of the Template hosts.

## PARAMETERS

## Name (string)

The name of the target RAS Template.

```
        Required?                    true

        Position?                    0

        Default value                

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## SiteId (uint)

Site ID of the specified RAS Template.

If the parameter is omitted, the site ID of the Licensing Server will be used.

```
        Required?                    false

        Position?                    1

        Default value                0

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## Id (uint)

The ID of the target RAS Template.

To obtain the ID, use the Get-RASTemplate cmdlet.

```
        Required?                    true

        Position?                    0

        Default value                0

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## InputObject ([Template](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/types/template.md))

An object of type Template which represents a RAS Template.

To obtain the object, use the Get-RASTemplate cmdlet.

```
        Required?                    true

        Position?                    0

        Default value                

        Accept pipeline input?       true (ByValue)

        Accept wildcard characters?  false
```

## ObjType ([Template](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/types/template.md))

Template object type.

Possible values: RDSTemplate, VDITemplate, AVDTemplate

```
        Required?                    true

        Position?                    named

        Default value                0

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## Command ([Template](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/types/template.md))

Template command.

Accepted values: EnterMaintenance, ExitMaintenance, RecreateHosts.

Possible values: EnterMaintenance, ExitMaintenance, RecreateHosts, RecreateDesktops

```
        Required?                    true

        Position?                    named

        Default value                0

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## ForceStopUpdateHosts (SwitchParameter)

Specifies whether to force stopping/updating of hosts.

```
        Required?                    false

        Position?                    named

        Default value                False

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## VDIHostId (string)

The ID of a host VM to be recreated.

```
        Required?                    false

        Position?                    named

        Default value                

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## RecreateAllHosts (SwitchParameter)

Specifies whether to re-create all hosts for the specified template.

```
        Required?                    false

        Position?                    named

        Default value                False

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## TemplateVersionId (uint)

The template version ID from which new hosts will be (re-)created from. Default: null.

```
        Required?                    false

        Position?                    named

        Default value                

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

## CreateTemplateVersion (SwitchParameter)

Switch determining whether or not a new template version is created on ExitMaintenance. Default: false.

```
        Required?                    false

        Position?                    named

        Default value                False

        Accept pipeline input?       false

        Accept wildcard characters?  false
```

(CommonParameters)

```
        This cmdlet supports the common parameters: Verbose, Debug,

        ErrorAction, ErrorVariable, WarningAction, WarningVariable,

        OutBuffer, PipelineVariable, and OutVariable. For more information, see 

        about_CommonParameters documentation. 
```

## INPUTS

[Template](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/types/template.md)

## OUTPUTS

-none-

## EXAMPLES

\*\*---------- EXAMPLE 1 ----------

Invoke-RASTemplate "TemplateName" -ObjType RDSTemplate -Command EnterMaintenance

Switch the RAS Template specified by name to maintenance mode in the Licensing Server site.

Since -ForceStopUpdateHosts is not included, hosts will not be stopped/updated.\
\*\*---------- EXAMPLE 2 ----------

Invoke-RASTemplate -ObjType VDITemplate -Id 10 -Command ExitMaintenance -ForceStopUpdateHosts

Switch the RAS Template specified by ID from the maintenance mode.

Since -ForceStopUpdateHosts is included, hosts will be stopped/updated, if required.\
\*\*---------- EXAMPLE 3 ----------

Invoke-RASTemplate "TemplateName" -ObjType RDSTemplate -Command RecreateHosts -VDIHostId 42312685-05c9-ca51-342d-b3943046edf1

Re-create the specified host of the RAS Template specified by name in the Licensing Server site.

Since -RecreateAllHosts is not included, only the specified host will be re-created.\
\*\*---------- EXAMPLE 4 ----------

Invoke-RASTemplate -ObjType RDSTemplate -InputObject $Template -Command RecreateHosts -RecreateAllHosts

Re-create all hosts of the RAS Template specified by the $Template object.\
\*\*---------- EXAMPLE 5 ----------

Get-RASTemplate -ObjType VDITemplate -Id 10 | Invoke-RASTemplateCmd -Command RecreateHosts -RecreateAllHosts

Re-create all hosts of the RAS Template specified by an object obtained from the pipeline output.

## RELATED LINKS

* [Get-RASTemplate](/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/commands/get-rastemplate.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.parallels.com/landing/ras-powershell-api-guide/v20/parallels-ras-powershell-admin-module/commands/invoke-rastemplate.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
